
#include <stdio.h>
#include <assert.h>


main(int argc, char* argv[])
{
  int retval, i, j;
  int numNodes;
  int saveArgc;
  char* progName;

  if(argc < 3){
	fprintf(stderr, "usage: %s numNodes progName [progArgs]\n", argv[0]);
	exit(1);
  }
  numNodes = atoi(argv[1]);
  progName = argv[2];
  
  retval = enroll("pvm_host");
  assert(retval >= 0);
  for(i=0; i<numNodes; ++i){
	retval = initiate(progName, (char*)0);
	assert(retval >= 0);
	while( ! status(progName, i))    sleep(1);
	initsend();
	putnint(&i, 1);
	putnint(&numNodes, 1);
	saveArgc = argc-2;
	putnint(&saveArgc, 1);
	for(j=0; j<saveArgc; ++j){
	  putstring(argv[2+j], 1);
	}
	retval = snd(progName, i, 0xfeed);
	assert(retval >= 0);
  }

  leave();
  exit(0);
}
